#include <Mega32.h>

#define FREQ 250
int count;     
unsigned char led; 

interrupt [TIM0_COMP] void tim0_comp(void) {
  count--;
  if (count == 0) {
    count = FREQ;
    led = led ^ 0xFF;
    PORTD = led;
  }
}

void init(void) {
  DDRD = 0xFF; 
  PORTD = 0x00; 
        
   led = 0xff;
   
  //set up timer 0  
  TIMSK=2;		//turn on timer 0 cmp match ISR 
  OCR0 = 250;  	//set the compare re to 250 time ticks
  //prescalar to 64 and turn on clear-on-match
  TCCR0=0b00001011;	
    
  count = FREQ;
  
  #asm
  	sei
  #endasm   
}

void main(void) {
  init();
  while (1) {
  
  }
}
