#include <Mega32.h>
#include <stdio.h>    
#include <stdlib.h>


     

typedef struct {
	unsigned char name_num, color, shape, special1, special2;
} Med;    
                             
typedef struct {     
	unsigned char med_num, amount;
} Dose;    
      
                       
typedef struct {
	unsigned char hour, min, num_doses;
	Dose doses[5];
} Bin;     
           
typedef struct {
	unsigned char num_names, num_meds;
	char names[450];
	Med meds[20];
	Bin bins[4];
} Schedule;
         
Schedule schedule;  
               
   
enum {INIT, BIN, DOSE, MEDHEAD, MED, STRING, DONE} serial_state;    
 
void send_confirm(void) {    
	putsf("OK\r");	
}   

void send_deny(void) {
	putsf("NO\r");
} 

void test(void) {
  char c;  
  unsigned char buffer[64];  
  int index, bin_num, dose_num, med_num, name_index, i;
  unsigned char ready = 0;  
  
  Schedule sched;
  Bin curr_bin; 
  Dose curr_dose;
  Med curr_med;
  
  index = 0; 
  bin_num = 0; 
  med_num = 0; 
  name_index = 0;
 
  //sprintf(buffer, "Schedule size: %i bytes\r\n", sizeof(Schedule));
  //puts(buffer); //remove this
 
  while (1) {  
    
  	while ((c = getchar()) != '\r') {
    	//putchar(c);       // echo - leave on?
    	buffer[index++] = c;
    }       
    //putchar('\r');
    //putchar('\n'); //remove this.
    
    if (index == 2 && buffer[0] == 'X' && buffer[1] == 'X') {
    	serial_state = INIT;
    	bin_num = 0;
    	index = 0;
    	continue;
    }
    
    switch (serial_state) { 
    	case INIT:
    		if (index == 2 && buffer[0] == 'U' && buffer[1] == 'S') {  
    			//putsf("READY FOR FIRST BIN (type B) ");
			send_confirm();
    			serial_state = BIN;
    		} else {
    			send_deny();
    		} break;
    	case BIN:
    		if (index == 1 && buffer[0] == 'B') {
    			//putsf("READY FOR BIN DETAILS (hour/min/doses) ");
			send_confirm();
    			ready = 1;
    		} else if (ready && index == 3) {   
    			curr_bin = sched.bins[bin_num++];
    			curr_bin.hour = buffer[0];
    			curr_bin.min  = buffer[1];
    			curr_bin.num_doses = buffer[2];
    			dose_num = 0;    
    			
    			//putsf("READY FOR FIRST DOSE (type D) ");
			   send_confirm();
    			ready = 0;    
    			if (dose_num == curr_bin.num_doses && bin_num < 4) {
    				 serial_state = BIN;  
    			} else if (dose_num == curr_bin.num_doses) { 
    				serial_state = MEDHEAD;
    			} else {
    				serial_state = DOSE;
			}
    		} else {
    			send_deny();
    		} break;
    	case DOSE:
    		if (index == 1 && buffer[0] == 'D') {
    			//putsf("READY FOR DOSE DETAILS (amount/med_num) ");
			send_confirm();
    			ready = 1;
    		} else if (ready &&	index == 2) {
    			curr_dose = curr_bin.doses[dose_num++];
    			curr_dose.amount = buffer[0];
    			curr_dose.med_num = buffer[1];
    			
    			//putsf("READY FOR NEXT DOSE, BIN, or MED HEAD ");
			send_confirm();
    			ready = 0;
    			if (dose_num == curr_bin.num_doses && bin_num < 4) {
    				 serial_state = BIN;  
    			} else if (dose_num == curr_bin.num_doses) { 
    				serial_state = MEDHEAD;
    			}
    		} else {
    			send_deny(); 
    		} break;
    	case MEDHEAD:   
    		if (index == 2 && buffer[0] == 'M' && buffer[1] == 'H') {
    	  		send_confirm();
    	    		ready = 1;
    	  	} else if (ready && index == 1) {
    	    		sched.num_meds = buffer[0];
    	    		med_num = 0;
    	    
    	    		send_confirm();
    	    		ready = 0;
    	    		serial_state = MED;
    	  	} else {
    	    		send_deny();
    	  	} break;
    	case MED:
    		if (index == 1 && buffer[0] == 'M') {
    	    		send_confirm();
    			ready = 1;
    		} else if (ready && index == 5) {
    			curr_med = sched.meds[med_num++];
    	    		curr_med.name_num = buffer[0];
    	    		curr_med.shape = buffer[1];
    		    curr_med.color = buffer[2];
    		    curr_med.special1 = buffer[3];
    		    curr_med.special2 = buffer[4]; 
    	    
    	send_confirm();
    	    ready = 0;
    	    if (med_num == sched.num_meds) {
    	      serial_state = STRING;
    	    }
    	  }
    	case STRING:
    	  if (index == 1 && buffer[0] == 'S') {
    	    send_confirm();
    	    ready = 1;
    	  } else if (ready) {
    	    for (i = 0; buffer[i] != 0; i++) {
    	      sched.names[name_index++] ==  buffer[i];
    	    }
    	    sched.names[name_index++] = 0;
    	    send_confirm();
    	    if (buffer[i+1] == 4) {
    	      serial_state = DONE;
    	    } 
    	  } else {
    	    send_deny();
    	  } break;
      case DONE:
    }    			
    			
    			
  	index = 0;  	
  }
}
          

void init(void) {
  UCSRB = 0x18;         
  UBRRL = 103 ;         //using a 16 MHz crystal (9600 baud)   
  
  serial_state = INIT;
  
} 

void main(void) {
  init();
  test();
}
  
  
